source: client/engine/Disk.lib @ d959834

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since d959834 was d959834, checked in by Ramón M. Gómez <ramongomez@…>, 6 years ago

#906: Declaring new variables as local.

  • Property mode set to 100755
File size: 57.2 KB
Line 
1#!/bin/bash
2#/**
3#@file    Disk.lib
4#@brief   Librería o clase Disk
5#@class   Disk
6#@brief   Funciones para gestión de discos y particiones.
7#@version 1.1.1
8#@warning License: GNU GPLv3+
9#*/
10
11
12# Función ficticia para lanzar parted con timeout, evitando cuelgues del programa.
13function parted ()
14{
15timeout -k 5s -s KILL 3s $(which parted) "$@"
16}
17
18
19#/**
20#         ogCreatePartitions int_ndisk str_parttype:int_partsize ...
21#@brief   Define el conjunto de particiones de un disco.
22#@param   int_ndisk      nº de orden del disco
23#@param   str_parttype   mnemónico del tipo de partición
24#@param   int_partsize   tamaño de la partición (en KB)
25#@return  (nada, por determinar)
26#@exception OG_ERR_FORMAT    formato incorrecto.
27#@exception OG_ERR_NOTFOUND  disco o partición no detectado (no es un dispositivo).
28#@exception OG_ERR_PARTITION error en partición o en tabla de particiones.
29#@attention El nº de partición se indica por el orden de los párametros \c parttype:partsize
30#@attention Pueden definirse particiones vacías de tipo \c EMPTY
31#@attention No puede definirse partición de cache y no se modifica si existe.
32#@note    Requisitos: sfdisk, parted, partprobe, awk
33#@todo    Definir atributos (arranque, oculta) y tamaños en MB, GB, etc.
34#@version 0.9 - Primera versión para OpenGnSys
35#@author  Ramon Gomez, ETSII Universidad de Sevilla
36#@date    2009/09/09
37#@version 0.9.1 - Corrección del redondeo del tamaño del disco.
38#@author  Ramon Gomez, ETSII Universidad de Sevilla
39#@date    2010/03/09
40#@version 1.0.4 - Llamada a función específica para tablas GPT.
41#@author  Universidad de Huelva
42#@date    2012/03/30
43#@version 1.1.1 - El inicio de la primera partición logica es el de la extendida más 4x512
44#@author  Irina Gomez, ETSII Universidad de Sevilla
45#@date    2016/07/11
46#*/ ##
47function ogCreatePartitions ()
48{
49# Variables locales.
50local ND DISK PTTYPE PART SECTORS START SIZE TYPE CACHEPART IODISCO IOSIZE CACHESIZE
51local EXTSTART EXTSIZE NVME_PREFIX tmpsfdisk
52# Si se solicita, mostrar ayuda.
53if [ "$*" == "help" ]; then
54    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk str_parttype:int_partsize ..." \
55           "$FUNCNAME 1 NTFS:10000000 EXT3:5000000 LINUX-SWAP:1000000"
56    return
57fi
58# Error si no se reciben al menos 2 parámetros.
59[ $# -ge 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
60
61# Nº total de sectores, para evitar desbordamiento (evitar redondeo).
62ND="$1"
63DISK=$(ogDiskToDev "$ND") || return $?
64PTTYPE=$(ogGetPartitionTableType $1)
65PTTYPE=${PTTYPE:-"MSDOS"}               # Por defecto para discos vacíos.
66case "$PTTYPE" in
67    GPT)   ogCreateGptPartitions "$@"
68           return $? ;;
69    MSDOS) ;;
70    *)     ogRaiseError $OG_ERR_PARTITION "$PTTYPE"
71           return $? ;;
72esac
73SECTORS=$(ogGetLastSector $1)
74# Se recalcula el nº de sectores del disco 1, si existe partición de caché.
75CACHEPART=$(ogFindCache 2>/dev/null)
76[ "$ND" = "${CACHEPART% *}" ] && CACHESIZE=$(ogGetCacheSize 2>/dev/null | awk '{print $0*2}')
77
78# Sector de inicio (la partición 1 empieza en el sector 63).
79IODISCO=$(ogDiskToDev $1)
80IOSIZE=$(fdisk -l $IODISCO | awk '/I\/O/ {print $4}')
81if [ "$IOSIZE" == "4096" ]; then
82    START=4096
83    SECTORS=$[SECTORS-8192]
84    [ -n "$CACHESIZE" ] && SECTORS=$[SECTORS-CACHESIZE+2048-(SECTORS-CACHESIZE)%2048-1]
85else
86    START=63
87    [ -n "$CACHESIZE" ] && SECTORS=$[SECTORS-CACHESIZE]
88fi
89PART=1
90
91# Fichero temporal de entrada para "sfdisk"
92tmpsfdisk=/tmp/sfdisk$$
93trap "rm -f $tmpsfdisk" 1 2 3 9 15
94
95echo "unit: sectors" >$tmpsfdisk
96echo                >>$tmpsfdisk
97
98NVME_PREFIX=""
99if [[ $DISK == *"nvme"* ]]; then
100        NVME_PREFIX="p"
101fi
102
103
104# Generar fichero de entrada para "sfdisk" con las particiones.
105shift
106while [ $# -gt 0 ]; do
107    # Conservar los datos de la partición de caché.
108    if [ "$ND $PART" == "$CACHEPART" -a -n "$CACHESIZE" ]; then
109        echo "$DISK$NVME_PREFIX$PART : start=$[SECTORS+1], size=$CACHESIZE, Id=ca" >>$tmpsfdisk
110        PART=$[PART+1]
111    fi
112    # Leer formato de cada parámetro - Tipo:Tamaño
113    TYPE="${1%%:*}"
114    SIZE="${1#*:}"
115    # Obtener identificador de tipo de partición válido.
116    ID=$(ogTypeToId "$TYPE" MSDOS)
117    [ "$TYPE" != "CACHE" -a -n "$ID" ] || ogRaiseError $OG_ERR_PARTITION "$TYPE" || return $?
118    # Comprobar tamaño numérico y convertir en sectores de 512 B.
119    [[ "$SIZE" == *([0-9]) ]] || ogRaiseError $OG_ERR_FORMAT "$SIZE" || return $?
120    SIZE=$[SIZE*2]
121    # Comprobar si la partición es extendida.
122    if [ $ID = 5 ]; then
123        [ $PART -le 4 ] || ogRaiseError $OG_ERR_FORMAT || return $?
124        # El inicio de la primera partición logica es el de la extendida más 4x512
125        let EXTSTART=$START+2048
126        let EXTSIZE=$SIZE-2048
127    fi
128    # Incluir particiones lógicas dentro de la partición extendida.
129    if [ $PART = 5 ]; then
130        [ -n "$EXTSTART" ] || ogRaiseError $OG_ERR_FORMAT || return $?
131        START=$EXTSTART
132        SECTORS=$[EXTSTART+EXTSIZE]
133    fi
134    # Generar datos para la partición.
135    echo "$DISK$NVME_PREFIX$PART : start=$START, size=$SIZE, Id=$ID" >>$tmpsfdisk
136    # Error si se supera el nº total de sectores.
137    START=$[START+SIZE]
138    if [ "$IOSIZE" == "4096" -a $PART -gt 4 ]; then
139        START=$[START+2048]
140    fi
141    [ $START -le $SECTORS ] || ogRaiseError $OG_ERR_FORMAT "$[START/2] > $[SECTORS/2]" || return $?
142    PART=$[PART+1]
143    shift
144done
145# Si no se indican las 4 particiones primarias, definirlas como vacías, conservando la partición de caché.
146while [ $PART -le 4 ]; do
147    if [ "$ND $PART" == "$CACHEPART" -a -n "$CACHESIZE" ]; then
148        echo "$DISK$NVME_PREFIX$PART : start=$[SECTORS+1], size=$CACHESIZE, Id=ca" >>$tmpsfdisk
149    else
150        echo "$DISK$NVME_PREFIX$PART : start=0, size=0, Id=0" >>$tmpsfdisk
151    fi
152    PART=$[PART+1]
153done
154# Si se define partición extendida sin lógicas, crear particion 5 vacía.
155if [ $PART = 5 -a -n "$EXTSTART" ]; then
156    echo "${DISK}5 : start=$EXTSTART, size=$EXTSIZE, Id=0" >>$tmpsfdisk
157fi
158
159# Desmontar los sistemas de archivos del disco antes de realizar las operaciones.
160ogUnmountAll $ND 2>/dev/null
161[ -n "$CACHESIZE" ] && ogUnmountCache 2>/dev/null
162
163# Si la tabla de particiones no es valida, volver a generarla.
164ogCreatePartitionTable $ND
165# Definir particiones y notificar al kernel.
166sfdisk -f $DISK < $tmpsfdisk 2>/dev/null && partprobe $DISK
167rm -f $tmpsfdisk
168[ -n "$CACHESIZE" ] && ogMountCache 2>/dev/null || return 0
169}
170
171
172#/**
173#         ogCreateGptPartitions int_ndisk str_parttype:int_partsize ...
174#@brief   Define el conjunto de particiones de un disco GPT
175#@param   int_ndisk      nº de orden del disco
176#@param   str_parttype   mnemónico del tipo de partición
177#@param   int_partsize   tamaño de la partición (en KB)
178#@return  (nada, por determinar)
179#@exception OG_ERR_FORMAT    formato incorrecto.
180#@exception OG_ERR_NOTFOUND  disco o partición no detectado (no es un dispositivo).
181#@exception OG_ERR_PARTITION error en partición o en tabla de particiones.
182#@attention El nº de partición se indica por el orden de los párametros \c parttype:partsize
183#@attention Pueden definirse particiones vacías de tipo \c EMPTY
184#@attention No puede definirse partición de caché y no se modifica si existe.
185#@note    Requisitos: sfdisk, parted, partprobe, awk
186#@todo    Definir atributos (arranque, oculta) y tamaños en MB, GB, etc.
187#@version 1.0.4 - Primera versión para OpenGnSys
188#@author  Universidad de Huelva
189#@date    2012/03/30
190#*/ ##
191function ogCreateGptPartitions ()
192{
193# Variables locales.
194local ND DISK PART SECTORS ALIGN START SIZE TYPE CACHEPART CACHESIZE DELOPTIONS OPTIONS
195# Si se solicita, mostrar ayuda.
196if [ "$*" == "help" ]; then
197    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk str_parttype:int_partsize ..." \
198           "$FUNCNAME 1 NTFS:10000000 EXT3:5000000 LINUX-SWAP:1000000"
199    return
200fi
201# Error si no se reciben menos de 2 parámetros.
202[ $# -ge 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
203
204# Nº total de sectores, para evitar desbordamiento (evitar redondeo).
205ND="$1"
206DISK=$(ogDiskToDev "$ND") || return $?
207# Se calcula el ultimo sector del disco (total de sectores usables)
208SECTORS=$(ogGetLastSector $1)
209# Se recalcula el nº de sectores del disco si existe partición de caché.
210CACHEPART=$(ogFindCache 2>/dev/null)
211[ "$ND" = "${CACHEPART% *}" ] && CACHESIZE=$(ogGetCacheSize 2>/dev/null | awk '{print $0*2}')
212[ -n "$CACHESIZE" ] && SECTORS=$[SECTORS-CACHESIZE]
213# Si el disco es GPT empieza en el sector 2048  por defecto, pero podria cambiarse
214ALIGN=$(sgdisk -D $DISK 2>/dev/null)
215START=$ALIGN
216PART=1
217
218# Leer parámetros con definición de particionado.
219shift
220
221while [ $# -gt 0 ]; do
222    # Si PART es la cache, nos la saltamos y seguimos con el siguiente numero para conservar los datos de la partición de caché.
223    if [ "$ND $PART" == "$CACHEPART" -a -n "$CACHESIZE" ]; then
224        PART=$[PART+1]
225    fi
226    # Leer formato de cada parámetro - Tipo:Tamaño
227    TYPE="${1%%:*}"
228    SIZE="${1#*:}"
229    # Error si la partición es extendida (no válida en discos GPT).
230    if [ "$TYPE" == "EXTENDED" ]; then
231        ogRaiseError $OG_ERR_PARTITION "EXTENDED"
232        return $?
233    fi
234    # Comprobar si existe la particion actual, capturamos su tamaño para ver si cambio o no
235    PARTSIZE=$(ogGetPartitionSize $ND $PART 2>/dev/null)
236    # En sgdisk no se pueden redimensionar las particiones, es necesario borrarlas y volver a crealas
237    [ $PARTSIZE ] && DELOPTIONS="$DELOPTIONS -d$PART"
238    # Creamos la particion
239    # Obtener identificador de tipo de partición válido.
240    ID=$(ogTypeToId "$TYPE" GPT)
241    [ "$TYPE" != "CACHE" -a -n "$ID" ] || ogRaiseError $OG_ERR_PARTITION "$TYPE" || return $?
242    # Comprobar tamaño numérico y convertir en sectores de 512 B.
243    [[ "$SIZE" == *([0-9]) ]] || ogRaiseError $OG_ERR_FORMAT "$SIZE" || return $?
244    SIZE=$[SIZE*2]
245    # SIZE debe ser múltiplo de ALIGN, si no gdisk lo mueve automáticamente.
246    DIV=$[$SIZE/$ALIGN]
247    SIZE=$[$DIV*$ALIGN]
248    # En el caso de que la partición sea EMPTY no se crea nada
249    if [ "$TYPE" != "EMPTY" ]; then
250        OPTIONS="$OPTIONS -n$PART:$START:+$SIZE -t$PART:$ID "
251    fi
252    START=$[START+SIZE]
253    # Error si se supera el nº total de sectores.
254    [ $START -le $SECTORS ] || ogRaiseError $OG_ERR_FORMAT "$[START/2] > $[SECTORS/2]" || return $?
255    PART=$[PART+1]
256    shift
257done
258
259# Desmontar los sistemas de archivos del disco antes de realizar las operaciones.
260ogUnmountAll $ND 2>/dev/null
261[ -n "$CACHESIZE" ] && ogUnmountCache 2>/dev/null
262
263# Si la tabla de particiones no es valida, volver a generarla.
264ogCreatePartitionTable $ND
265# Definir particiones y notificar al kernel.
266# Borramos primero las particiones y luego creamos las nuevas
267sgdisk $DELOPTIONS $OPTIONS $DISK 2>/dev/null && partprobe $DISK
268[ -n "$CACHESIZE" ] && ogMountCache 2>/dev/null || return 0
269}
270
271
272#/**
273#         ogCreatePartitionTable int_ndisk [str_tabletype]
274#@brief   Genera una tabla de particiones en caso de que no sea valida, si es valida no hace nada.
275#@param   int_ndisk      nº de orden del disco
276#@param   str_tabletype  tipo de tabla de particiones (opcional)
277#@return  (por determinar)
278#@exception OG_ERR_FORMAT   Formato incorrecto.
279#@exception OG_ERR_NOTFOUND Disco o particion no corresponden con un dispositivo.
280#@note    tabletype: { MSDOS, GPT }, MSDOS por defecto
281#@note    Requisitos: fdisk, gdisk, parted
282#@version 1.0.4 - Primera versión compatible con OpenGnSys.
283#@author  Universidad de Huelva
284#@date    2012/03/06
285#@version 1.0.6a - Adaptar creación de nueva tabla MSDOS.
286#@author  Ramon Gomez, ETSII Universidad de Sevilla
287#@date    2016/01/29
288#*/ ##
289function ogCreatePartitionTable ()
290{
291# Variables locales.
292local DISK PTTYPE CREATE CREATEPTT
293
294# Si se solicita, mostrar ayuda.
295if [ "$*" == "help" ]; then
296    ogHelp "$FUNCNAME int_ndisk [str_partype]" \
297           "$FUNCNAME 1 GPT" "$FUNCNAME 1"
298    return
299fi
300# Error si no se reciben 1 o 2 parámetros.
301case $# in
302    1)  CREATEPTT="" ;;
303    2)  CREATEPTT="$2" ;;
304    *)  ogRaiseError $OG_ERR_FORMAT
305        return $? ;;
306esac
307
308# Capturamos el tipo de tabla de particiones actual
309DISK=$(ogDiskToDev $1) || return $?
310PTTYPE=$(ogGetPartitionTableType $1)
311PTTYPE=${PTTYPE:-"MSDOS"}               # Por defecto para discos vacíos.
312CREATEPTT=${CREATEPTT:-"$PTTYPE"}
313
314# Si la tabla actual y la que se indica son iguales, se comprueba si hay que regenerarla.
315if [ "$CREATEPTT" == "$PTTYPE" ]; then
316    case "$PTTYPE" in
317        GPT)   [ ! $(sgdisk -p $DISK 2>&1 >/dev/null) ] || CREATE="GPT" ;;
318        MSDOS) [ $(parted -s $DISK print >/dev/null) ] || CREATE="MSDOS" ;;
319    esac
320else
321    CREATE="$CREATEPTT"
322fi
323# Dependiendo del valor de CREATE, creamos la tabla de particiones en cada caso.
324case "$CREATE" in
325    GPT)
326        # Si es necesario crear una tabla GPT pero la actual es MSDOS
327        if [ "$PTTYPE" == "MSDOS" ]; then
328            sgdisk -go $DISK
329        else
330            echo -e "2\nw\nY\n" | gdisk $DISK
331        fi
332        partprobe $DISK 2>/dev/null
333        ;;
334    MSDOS)
335        # Si es necesario crear una tabla MSDOS pero la actual es GPT
336        if [ "$PTTYPE" == "GPT" ]; then
337            sgdisk -Z $DISK
338        fi
339        # Crear y borrar una partición para que la tabla se genere bien.
340        echo -e "o\nn\np\n\n\n\nd\n\nw" | fdisk $DISK
341        partprobe $DISK 2>/dev/null
342        ;;
343esac
344}
345
346
347#/**
348#         ogDeletePartitionTable ndisk
349#@brief   Borra la tabla de particiones del disco.
350#@param   int_ndisk      nº de orden del disco
351#@return  la informacion propia del fdisk
352#@version 0.1 -  Integracion para OpenGnSys
353#@author  Antonio J. Doblas Viso. Universidad de Malaga
354#@date    2008/10/27
355#@version 1.0.4 - Adaptado para su uso con discos GPT
356#@author  Universidad de Huelva
357#@date    2012/03/13
358#*/ ##
359function ogDeletePartitionTable ()
360{
361# Variables locales.
362local DISK
363
364# Si se solicita, mostrar ayuda.
365if [ "$*" == "help" ]; then
366    ogHelp "$FUNCNAME int_ndisk" "$FUNCNAME 1"
367    return
368fi
369# Error si no se reciben 1 parámetros.
370[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
371
372# Obteniendo Identificador linux del disco.
373DISK=$(ogDiskToDev $1) || return $?
374# Crear una tabla de particiones vacía.
375case "$(ogGetPartitionTableType $1)" in
376    GPT)    sgdisk -o $DISK ;;
377    MSDOS)  echo -ne "o\nw" | fdisk $DISK ;;
378esac
379}
380
381
382#/**
383#         ogDevToDisk path_device | LABEL="str_label" | UUID="str_uuid"
384#@brief   Devuelve el nº de orden de dicso (y partición) correspondiente al nombre de fichero de dispositivo o a la etiqueta o UUID del sistema de archivos asociado.
385#@param   path_device  Camino del fichero de dispositivo.
386#@param   str_label    etiqueta de sistema de archivos.
387#@param   str_uuid     UUID de sistema de archivos.
388#@return  int_ndisk (para dispositivo de disco)
389#@return  int_ndisk int_npartition (para dispositivo de partición).
390#@exception OG_ERR_FORMAT   Formato incorrecto.
391#@exception OG_ERR_NOTFOUND Dispositivo no detectado.
392#@note    Solo se acepta en cada llamada 1 de los 3 tipos de parámetros.
393#@version 0.1 -  Integracion para Opengnsys  -  EAC: DiskEAC() en ATA.lib
394#@author  Antonio J. Doblas Viso, Universidad de Malaga
395#@date    2008/10/27
396#@version 0.9 - Primera version para OpenGnSys
397#@author  Ramon Gomez, ETSII Universidad Sevilla
398#@date    2009/07/20
399#@version 1.0.6 - Soporta parámetro con UIID o etiqueta.
400#@author  Ramon Gomez, ETSII Universidad Sevilla
401#@date    2014/07/13
402#*/ ##
403function ogDevToDisk ()
404{
405# Variables locales.
406local CACHEFILE DEV PART NVME_PREFIX d n
407# Si se solicita, mostrar ayuda.
408if [ "$*" == "help" ]; then
409    ogHelp "$FUNCNAME" "$FUNCNAME path_device | LABEL=str_label | UUID=str_uuid" \
410           "$FUNCNAME /dev/sda  =>  1" \
411           "$FUNCNAME /dev/sda1  =>  1 1" \
412           "$FUNCNAME LABEL=CACHE  =>  1 4"
413    return
414fi
415
416# Error si no se recibe 1 parámetro.
417[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
418
419# Obtener dispositivo a partir de camino, etiqueta o UUID.
420DEV="$1"
421case "$DEV" in
422    LABEL=*)    DEV=$(blkid -L "${1#*=}") ;;
423    PARTLABEL=*) DEV=$(realpath "/dev/disk/by-partlabel/${1#*=}" 2>/dev/null) ;;
424    PARTUUID=*) DEV=$(realpath "/dev/disk/by-partuuid/${1#*=}" 2>/dev/null) ;;
425    UUID=*)     DEV=$(blkid -U "${1#*=}") ;;
426esac
427
428# Error si no es fichero de bloques o directorio (para LVM).
429[ -b "$DEV" -o -d "$DEV" ] || ogRaiseError $OG_ERR_NOTFOUND "$1" || return $?
430
431# Buscar en fichero de caché de discos.
432CACHEFILE=/var/cache/disks.cfg
433PART=$(awk -F: -v d="$DEV" '{if ($2==d) {print $1}}' $CACHEFILE 2>/dev/null)
434if [ -n "$PART" ]; then
435    echo "$PART"
436    return
437fi
438# Si no se encuentra, procesa todos los discos para devolver su nº de orden y de partición.
439n=1
440for d in $(ogDiskToDev); do
441NVME_PREFIX=""
442if [[ $d == *"nvme"* ]]; then
443        NVME_PREFIX="p"
444fi
445
446
447    [ -n "$(echo $DEV | grep $d)" ] && echo "$n ${DEV#$d$NVME_PREFIX}" && return
448    n=$[n+1]
449done
450ogRaiseError $OG_ERR_NOTFOUND "$1"
451return $OG_ERR_NOTFOUND
452}
453
454
455#/**
456#         ogDiskToDev [int_ndisk [int_npartition]]
457#@brief   Devuelve la equivalencia entre el nº de orden del dispositivo (dicso o partición) y el nombre de fichero de dispositivo correspondiente.
458#@param   int_ndisk      nº de orden del disco
459#@param   int_npartition nº de orden de la partición
460#@return  Para 0 parametros: Devuelve los nombres de ficheros  de los dispositivos sata/ata/usb linux encontrados.
461#@return  Para 1 parametros: Devuelve la ruta del disco duro indicado.
462#@return  Para 2 parametros: Devuelve la ruta de la particion indicada.
463#@exception OG_ERR_FORMAT   Formato incorrecto.
464#@exception OG_ERR_NOTFOUND Dispositivo no detectado.
465#@note    Requisitos: awk, lvm
466#@version 0.1 -  Integracion para Opengnsys  -  EAC: Disk() en ATA.lib;  HIDRA: DetectarDiscos.sh
467#@author Ramon Gomez, ETSII Universidad de Sevilla
468#@Date    2008/06/19
469#@author  Antonio J. Doblas Viso, Universidad de Malaga
470#@date    2008/10/27
471#@version 0.9 - Primera version para OpenGnSys
472#@author  Ramon Gomez, ETSII Universidad Sevilla
473#@date    2009-07-20
474#@version 1.0.5 - Comprobación correcta de parámetros para soportar valores > 9.
475#@author  Ramon Gomez, ETSII Universidad Sevilla
476#@date    2013-05-07
477#@version 1.0.6 - Soportar RAID hardware y Multipath.
478#@author  Ramon Gomez, ETSII Universidad Sevilla
479#@date    2014-09-23
480#@version 1.1.0 - Usar caché de datos y soportar pool de volúmenes ZFS.
481#@author  Ramon Gomez, ETSII Universidad Sevilla
482#@date    2016-05-27
483#*/ ##
484function ogDiskToDev ()
485{
486# Variables locales
487local CACHEFILE ALLDISKS MPATH VOLGROUPS ZFSVOLS DISK PART ZPOOL i
488
489# Si se solicita, mostrar ayuda.
490if [ "$*" == "help" ]; then
491    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk [int_npartition]" \
492           "$FUNCNAME      =>  /dev/sda /dev/sdb" \
493           "$FUNCNAME 1    =>  /dev/sda" \
494           "$FUNCNAME 1 1  =>  /dev/sda1"
495    return
496fi
497
498# Borrar fichero de caché de configuración si hay cambios en las particiones.
499CACHEFILE=/var/cache/disks.cfg
500if ! diff -q <(cat /proc/partitions) /tmp/.partitions &>/dev/null; then
501    # Guardar copia de las particiones definidas para comprobar cambios.
502    cp -a /proc/partitions /tmp/.partitions
503    rm -f $CACHEFILE
504fi
505
506# Si existe una correspondencia con disco/dispositivo en el caché; mostrarlo y salir.
507PART=$(awk -F: -v d="$*" '{if ($1==d) {print $2}}' $CACHEFILE 2>/dev/null)
508if [ -n "$PART" ]; then
509    echo "$PART"
510    return
511fi
512
513# Continuar para detectar nuevos dispositivos.
514# Listar dispositivos de discos.
515ALLDISKS=$((lsblk -n -e 1,2 -x MAJ:MIN 2>/dev/null || lsblk -n -e 1,2) | \
516           awk '$6~/^disk$/ {gsub(/!/,"/"); printf "/dev/%s ",$1}')
517#ALLDISKS=$(lsblk -Jdp | jq -r '.blockdevices[] | select(.type=="disk").name')
518# Listar volúmenes lógicos.
519VOLGROUPS=$(vgs -a --noheadings 2>/dev/null | awk '{printf "/dev/%s ",$1}')
520ALLDISKS="$ALLDISKS $VOLGROUPS"
521
522# Detectar caminos múltiples (ignorar mensaje si no está configurado Multipath).
523if MPATH=$(multipath -l -v 1 2>/dev/null | awk '{printf "/dev/mapper/%s ",$1}'; exit ${PIPESTATUS[0]}); then
524    # Quitar de la lista los discos que forman parte de Multipath.
525    for i in $(multipath -ll | awk '$6=="ready" {printf "/dev/%s ",$3}'); do
526        ALLDISKS="${ALLDISKS//$i/}"
527    done
528    # Añadir caminos múltiples a los discos detectados.
529    ALLDISKS="$ALLDISKS $MPATH"
530fi
531
532# Detectar volúmenes ZFS.
533ZFSVOLS=$(blkid | awk -F: '/zfs/ {print $1}')
534ALLDISKS="$ALLDISKS $ZFSVOLS"
535
536# Mostrar salidas segun el número de parametros.
537case $# in
538    0)  # Muestra todos los discos, separados por espacios.
539        echo $ALLDISKS
540        ;;
541    1)  # Error si el parámetro no es un número positivo.
542        [[ "$1" =~ ^[1-9][0-9]*$ ]] || ogRaiseError $OG_ERR_FORMAT "$1" || return $?
543        DISK=$(echo "$ALLDISKS" | awk -v n=$1 '{print $n}')
544        # Error si el fichero no existe.
545        [ -e "$DISK" ] || ogRaiseError $OG_ERR_NOTFOUND "$1" || return $?
546        # Actualizar caché de configuración y mostrar dispositivo.
547        echo "$*:$DISK" >> $CACHEFILE
548        echo "$DISK"
549        ;;
550    2)  # Error si los 2 parámetros no son números positivos.
551        [[ "$1" =~ ^[1-9][0-9]*$ ]] && [[ "$2" =~ ^[1-9][0-9]*$ ]] || ogRaiseError $OG_ERR_FORMAT "$1 $2" || return $?
552        DISK=$(echo "$ALLDISKS" | awk -v n=$1 '{print $n}')
553        [ -e "$DISK" ] || ogRaiseError $OG_ERR_NOTFOUND "$1" || return $?
554        PART="$DISK$2"
555        # Comprobar si es partición.
556        if [ -b "$PART" ]; then
557            # Actualizar caché de configuración y mostrar dispositivo.
558            echo "$*:$PART" >> $CACHEFILE
559            echo "$PART"
560        else
561            # Comprobar si RAID o Multipath (tener en cuenta enlace simbólico).
562            PART="${DISK}p$2"
563            if [ "$(stat -L -c "%A" "$PART" 2>/dev/null | cut -c1)" == "b" ]; then
564                # Actualizar caché de configuración y mostrar dispositivo.
565                echo "$*:$PART" >> $CACHEFILE
566                echo "$PART"
567            else
568                PART=""
569                # Comprobar si volumen lógico.          /* (comentario Doxygen)
570                if ogCheckStringInGroup "$DISK" "$VOLGROUPS"; then
571                    PART=$(lvscan -a 2>/dev/null | \
572                           awk -F\' -v n=$2 "\$2~/^${DISK//\//\\/}\// {if (NR==n) print \$2}")
573                    [ -e "$PART" ] || ogRaiseError $OG_ERR_NOTFOUND "$1 $2" || return $?
574                    #                                   (comentario Doxygen) */
575                fi
576                # Comprobar si volumen ZFS que puede ser montado.
577                if ogCheckStringInGroup "$DISK" "$ZFSVOLS"; then
578                    zpool import -f -R /mnt -N -a 2>/dev/null
579                    ZPOOL=$(blkid -s LABEL -o value $DISK)
580                    PART=$(zfs list -Hp -o name,canmount,mountpoint -r $ZPOOL | \
581                           awk -v n=$2 '$2=="on" && $3!="none" {c++; if (c==n) print $1}')
582                fi
583                # Salir si no se encuentra dispositivo.
584                [ -n "$PART" ] || ogRaiseError $OG_ERR_NOTFOUND "$1 $2" || return $?
585                # Devolver camino al dispositivo.
586                # Actualizar caché de configuración y mostrar dispositivo.
587                echo "$*:$PART" >> $CACHEFILE
588                echo "$PART"
589            fi
590        fi
591        ;;
592    *)  # Formato erroneo.
593        ogRaiseError $OG_ERR_FORMAT
594        return $OG_ERR_FORMAT
595        ;;
596esac
597}
598
599
600#/**
601#         ogGetDiskSize int_ndisk
602#@brief   Muestra el tamaño en KB de un disco.
603#@param   int_ndisk   nº de orden del disco
604#@return  int_size  - Tamaño en KB del disco.
605#@exception OG_ERR_FORMAT   formato incorrecto.
606#@exception OG_ERR_NOTFOUND disco o particion no detectado (no es un dispositivo).
607#@note    Requisitos: sfdisk, awk
608#@version 0.9.2 - Primera version para OpenGnSys
609#@author  Ramon Gomez, ETSII Universidad de Sevilla
610#@date    2010/09/15
611#@version 1.0.6 - Soportar LVM.
612#@author  Universidad de Huelva
613#@date    2014/09/04
614#*/ ##
615function ogGetDiskSize ()
616{
617# Variables locales.
618local DISK SIZE
619
620# Si se solicita, mostrar ayuda.
621if [ "$*" == "help" ]; then
622    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" "$FUNCNAME 1  => 244198584"
623    return
624fi
625# Error si no se recibe 1 parámetro.
626[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
627
628# Obtener el tamaño del disco.
629DISK="$(ogDiskToDev $1)" || return $?
630SIZE=$(awk -v D=${DISK#/dev/} '{if ($4==D) {print $3}}' /proc/partitions)
631# Si no, obtener tamaño del grupo de volúmenes.
632[ -z "$SIZE" ] && SIZE=$(vgs --noheadings --units=B -o dev_size $DISK 2>/dev/null | \
633                         awk '{print $1/1024}')
634
635# Mostrar salida.
636[ -n "$SIZE" ] && echo "$SIZE"
637}
638
639
640#/**
641#         ogGetDiskType path_device
642#@brief   Muestra el tipo de disco (real, RAID, meta-disco, USB, etc.).
643#@param   path_device  Dispositivo
644#@exception OG_ERR_FORMAT   formato incorrecto.
645#@exception OG_ERR_NOTFOUND disco no detectado o no es un dispositivo de bloques.
646#@note    Requisitos: udevadm
647#@version 1.1.1 - Primera version para OpenGnsys
648#@author  Ramon Gomez, ETSII Universidad de Sevilla
649#@date    2018-02-27
650#*/ ##
651function ogGetDiskType ()
652{
653# Variables locales
654local DEV MAJOR TYPE
655
656# Si se solicita, mostrar ayuda.
657if [ "$*" == "help" ]; then
658    ogHelp "$FUNCNAME" "$FUNCNAME path_device" \
659           "$FUNCNAME /dev/sdb  =>  USB"
660    return
661fi
662# Error si no se recibe 1 parámetro.
663[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
664
665# Obtener el driver del dispositivo de bloques.
666[ -b "$1" ] || ogRaiseError $OG_ERR_NOTFOUND "$1" || return $?
667DEV=${1#/dev/}
668MAJOR=$(awk -v D="$DEV" '{if ($4==D) print $1;}' /proc/partitions)
669TYPE=$(awk -v D=$MAJOR '/Block/ {bl=1} {if ($1==D&&bl) print toupper($2)}' /proc/devices)
670# Devolver mnemónico del driver de dispositivo.
671case "$TYPE" in
672    SD)
673        TYPE="DISK"
674        udevadm info -q property $1 2>/dev/null | grep -q "^ID_BUS=usb" && TYPE="USB"
675        ;;
676    BLKEXT)
677        TYPE="NVM"
678        ;;
679    SR|IDE*)
680        TYPE="CDROM"        # FIXME Comprobar discos IDE.
681        ;;
682    MD|CCISS*)
683        TYPE="RAID"
684        ;;
685    DEVICE-MAPPER)
686        TYPE="MAPPER"       # FIXME Comprobar LVM y RAID.
687        ;;
688esac
689echo $TYPE
690}
691
692
693#/**
694#         ogGetEsp
695#@brief   Devuelve números de disco y partición para la partición EFI (ESP).
696#*/ ##
697function ogGetEsp ()
698{
699local PART d
700for d in $(blkid -t TYPE=vfat -o device); do
701    PART="$(ogDevToDisk $d)"
702    if [ "$(ogGetPartitionId $PART)" == "$(ogTypeToId EFI GPT)" ]; then
703        echo $PART
704        break
705    fi
706done
707}
708
709
710#/**
711#         ogGetLastSector int_ndisk [int_npart]
712#@brief   Devuelve el último sector usable del disco o de una partición.
713#@param   int_ndisk      nº de orden del disco
714#@param   int_npart      nº de orden de la partición (opcional)
715#@return  Último sector usable.
716#@exception OG_ERR_FORMAT   Formato incorrecto.
717#@exception OG_ERR_NOTFOUND Disco o partición no corresponde con un dispositivo.
718#@note    Requisitos: sfdisk, sgdisk
719#@version 1.0.4 - Primera versión compatible con OpenGnSys.
720#@author  Universidad de Huelva
721#@date    2012-06-03
722#@version 1.0.6b - uso de sgdisk para todo tipo de particiones. Incidencia #762
723#@author  Universidad de Málaga
724#@date    2016-11-10
725#*/ ##
726function ogGetLastSector ()
727{
728# Variables locales
729local DISK PART LASTSECTOR
730
731# Si se solicita, mostrar ayuda.
732if [ "$*" == "help" ]; then
733    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk [int_npart]" \
734           "$FUNCNAME 1  =>  488392064" \
735           "$FUNCNAME 1 1  =>  102400062"
736    return
737fi
738
739# Obtener último sector.
740case $# in
741    1)  # Para un disco.
742        DISK=$(ogDiskToDev $1) || return $?
743        LASTSECTOR=$(LANG=C sgdisk -p $DISK | awk '/last usable sector/ {print($(NF))}')
744        ;;
745    2)  # Para una partición.
746        DISK=$(ogDiskToDev $1) || return $?
747        PART=$(ogDiskToDev $1 $2) || return $?
748        LASTSECTOR=$(LANG=C sgdisk -p $DISK | awk -v P="$2" '{if ($1==P) print $3}')
749        ;;
750    *)  # Error si se reciben más parámetros.
751        ogRaiseError $OG_ERR_FORMAT
752        return $? ;;
753esac
754echo $LASTSECTOR
755}
756
757
758#/**
759#         ogGetPartitionActive int_ndisk
760#@brief   Muestra que particion de un disco esta marcada como de activa.
761#@param   int_ndisk   nº de orden del disco
762#@return  int_npart   Nº de partición activa
763#@exception OG_ERR_FORMAT Formato incorrecto.
764#@exception OG_ERR_NOTFOUND Disco o particion no corresponden con un dispositivo.
765#@note    Requisitos: parted
766#@todo    Queda definir formato para atributos (arranque, oculta, ...).
767#@version 0.9 - Primera version compatible con OpenGnSys.
768#@author  Ramon Gomez, ETSII Universidad de Sevilla
769#@date    2009/09/17
770#*/ ##
771function ogGetPartitionActive ()
772{
773# Variables locales
774local DISK
775
776# Si se solicita, mostrar ayuda.
777if [ "$*" == "help" ]; then
778    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" "$FUNCNAME 1  =>  1"
779    return
780fi
781# Error si no se recibe 1 parámetro.
782[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
783
784# Comprobar que el disco existe y listar su partición activa.
785DISK="$(ogDiskToDev $1)" || return $?
786LANG=C parted -sm $DISK print 2>/dev/null | awk -F: '$7~/boot/ {print $1}'
787}
788
789
790#/**
791#         ogGetPartitionId int_ndisk int_npartition
792#@brief   Devuelve el mnemónico con el tipo de partición.
793#@param   int_ndisk      nº de orden del disco
794#@param   int_npartition nº de orden de la partición
795#@return  Identificador de tipo de partición.
796#@exception OG_ERR_FORMAT   Formato incorrecto.
797#@exception OG_ERR_NOTFOUND Disco o partición no corresponde con un dispositivo.
798#@note    Requisitos: sfdisk
799#@version 0.9 - Primera versión compatible con OpenGnSys.
800#@author  Ramon Gomez, ETSII Universidad de Sevilla
801#@date    2009-03-25
802#@version 1.0.2 - Detectar partición vacía.
803#@author  Ramon Gomez, ETSII Universidad de Sevilla
804#@date    2011-12-23
805#@version 1.0.6 - Soportar LVM.
806#@author  Universidad de Huelva
807#@date    2014-09-04
808#@version 1.1.0 - Soportar pool de volúmenes ZFS.
809#@author  Ramon Gomez, ETSII Universidad Sevilla
810#@date    2014-11-14
811#*/ ##
812function ogGetPartitionId ()
813{
814# Variables locales.
815local DISK ID
816
817# Si se solicita, mostrar ayuda.
818if [ "$*" == "help" ]; then
819    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
820           "$FUNCNAME 1 1  =>  7"
821    return
822fi
823# Error si no se reciben 2 parámetros.
824[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
825
826# Detectar y mostrar el id. de tipo de partición.
827DISK=$(ogDiskToDev $1) || return $?
828case "$(ogGetPartitionTableType $1)" in
829    GPT)    ID=$(sgdisk -p $DISK 2>/dev/null | awk -v p="$2" '{if ($1==p) print $6;}') || ogRaiseError $OG_ERR_NOTFOUND "$1,$2" || return $?
830            [ "$ID" == "8300" -a "$1 $2" == "$(ogFindCache)" ] && ID=CA00
831            ;;
832    MSDOS)  ID=$(sfdisk --id $DISK $2 2>/dev/null) || ogRaiseError $OG_ERR_NOTFOUND "$1,$2" || return $? ;;
833    LVM)    ID=10000 ;;
834    ZPOOL)  ID=10010 ;;
835esac
836echo $ID
837}
838
839
840#/**
841#         ogGetPartitionSize int_ndisk int_npartition
842#@brief   Muestra el tamano en KB de una particion determinada.
843#@param   int_ndisk      nº de orden del disco
844#@param   int_npartition nº de orden de la partición
845#@return  int_partsize - Tamaño en KB de la partición.
846#@exception OG_ERR_FORMAT   formato incorrecto.
847#@exception OG_ERR_NOTFOUND disco o particion no detectado (no es un dispositivo).
848#@note    Requisitos: sfdisk, awk
849#@version 0.1 -  Integracion para Opengnsys  -  EAC: SizePartition () en ATA.lib
850#@author  Antonio J. Doblas Viso, Universidad de Malaga
851#@date    2008/10/27
852#@version 0.9 - Primera version para OpenGnSys
853#@author  Ramon Gomez, ETSII Universidad de Sevilla
854#@date    2009/07/24
855#@version 1.1.0 - Sustituir "sfdisk" por "partx".
856#@author  Ramon Gomez, ETSII Universidad de Sevilla
857#@date    2016/05/04
858#*/ ##
859function ogGetPartitionSize ()
860{
861# Variables locales.
862local PART SIZE
863
864# Si se solicita, mostrar ayuda.
865if [ "$*" == "help" ]; then
866    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
867           "$FUNCNAME 1 1  =>  10000000"
868    return
869fi
870# Error si no se reciben 2 parámetros.
871[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
872
873# Devolver tamaño de partición, del volumen lógico o del sistema de archivos (para ZFS).
874PART="$(ogDiskToDev $1 $2)" || return $?
875SIZE=$(partx -gbo SIZE $PART 2>/dev/null | awk '{print int($1/1024)}')
876[ -z "$SIZE" ] && SIZE=$(lvs --noheadings -o lv_size --units k $PART | awk '{printf "%d",$0}')
877[ -z "$SIZE" ] && SIZE=$(ogGetFsSize $1 $2)
878echo ${SIZE:-0}
879}
880
881
882#/**
883#         ogGetPartitionsNumber int_ndisk
884#@brief   Detecta el numero de particiones del disco duro indicado.
885#@param   int_ndisk      nº de orden del disco
886#@return  Devuelve el numero paritiones del disco duro indicado
887#@warning Salidas de errores no determinada
888#@attention Requisitos: parted
889#@note    Notas sin especificar
890#@version 0.1 -  Integracion para Opengnsys  -  EAC:  DetectNumberPartition () en ATA.lib
891#@author  Antonio J. Doblas Viso. Universidad de Malaga
892#@date    Date: 27/10/2008
893#@version 1.0 - Uso de sfdisk Primera version para OpenGnSys
894#@author  Ramon Gomez, ETSII Universidad de Sevilla
895#@date    2009-07-24
896#@version 1.0.4 - Uso de /proc/partitions para detectar el numero de particiones
897#@author  Universidad de Huelva
898#@date    2012-03-28
899#@version 1.0.6 - Soportar LVM.
900#@author  Universidad de Huelva
901#@date    2014-09-04
902#@version 1.1.0 - Soportar ZFS y sustituir "sfdisk" por "partx".
903#@author  Ramon Gomez, ETSII Universidad Sevilla
904#@date    2016-04-28
905#*/ ##
906function ogGetPartitionsNumber ()
907{
908# Variables locales.
909local DISK
910# Si se solicita, mostrar ayuda.
911if [ "$*" == "help" ]; then
912    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
913           "$FUNCNAME 1  =>  3"
914    return
915fi
916# Error si no se recibe 1 parámetro.
917[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
918
919# Contar el nº de veces que aparece el disco en su lista de particiones.
920DISK=$(ogDiskToDev $1) 2>/dev/null
921case "$(ogGetPartitionTableType $1)" in
922    GPT|MSDOS)
923            partx -gso NR $DISK 2>/dev/null | awk -v p=0 '{p=$1} END {print p}' ;;
924    LVM)    lvs --noheadings $DISK 2>/dev/null | wc -l ;;
925    ZPOOL)  zpool list &>/dev/null || modprobe zfs
926            zpool import -f -R /mnt -N -a 2>/dev/null
927            zfs list -Hp -o name,canmount,mountpoint -r $(blkid -s LABEL -o value $DISK) | \
928                    awk '$2=="on" && $3!="none" {c++}
929                         END {print c}'
930            ;;
931esac
932}
933
934
935#/**
936#         ogGetPartitionTableType int_ndisk
937#@brief   Devuelve el tipo de tabla de particiones del disco (GPT o MSDOS)
938#@param   int_ndisk       nº de orden del disco
939#@return  str_tabletype - Tipo de tabla de paritiones
940#@warning Salidas de errores no determinada
941#@note    tabletype = { MSDOS, GPT }
942#@note    Requisitos: blkid, parted, vgs
943#@version 1.0.4 - Primera versión para OpenGnSys
944#@author  Universidad de Huelva
945#@date    2012/03/01
946#@version 1.0.6 - Soportar LVM.
947#@author  Universidad de Huelva
948#@date    2014-09-04
949#@version 1.1.0 - Mejorar rendimiento y soportar ZFS.
950#@author  Ramon Gomez, ETSII Universidad Sevilla
951#@date    2014-11-14
952#*/ ##
953function ogGetPartitionTableType ()
954{
955# Variables locales.
956local DISK TYPE
957
958# Si se solicita, mostrar ayuda.
959if [ "$*" == "help" ]; then
960    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
961           "$FUNCNAME 1  =>  MSDOS"
962    return
963fi
964# Error si no se recibe 1 parámetro.
965[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
966
967# Sustituye n de disco por su dispositivo.
968DISK=$(ogDiskToDev $1) || return $?
969
970# Comprobar tabla de particiones.
971if [ -b $DISK ]; then
972    TYPE=$(parted -sm $DISK print 2>/dev/null | awk -F: -v D=$DISK '{ if($1 == D) print toupper($6)}')
973    [ -z "$TYPE" ] && TYPE=$(parted -sm $DISK print 2>/dev/null | awk -F: -v D=$DISK '{ if($1 == D) print toupper($6)}')
974fi
975# Comprobar si es volumen lógico.
976[ -d $DISK ] && vgs $DISK &>/dev/null && TYPE="LVM"
977# Comprobar si es pool de ZFS.
978[ -z "$TYPE" -o "$TYPE" == "UNKNOWN" ] && [ -n "$(blkid -s TYPE $DISK | grep zfs)" ] && TYPE="ZPOOL"
979
980# Mostrar salida.
981[ -n "$TYPE" ] && echo "$TYPE"
982}
983
984
985#/**
986#         ogGetPartitionType int_ndisk int_npartition
987#@brief   Devuelve el mnemonico con el tipo de partición.
988#@param   int_ndisk      nº de orden del disco
989#@param   int_npartition nº de orden de la partición
990#@return  Mnemonico
991#@note    Mnemonico: valor devuelto por ogIdToType.
992#@exception OG_ERR_FORMAT   Formato incorrecto.
993#@exception OG_ERR_NOTFOUND Disco o particion no corresponden con un dispositivo.
994#@version 0.1 -  Integracion para Opengnsys  -  EAC:   TypeFS() en ATA.lib
995#@author  Antonio J. Doblas Viso. Universidad de Malaga
996#@date    2008-10-27
997#@version 0.9 - Primera adaptacion para OpenGnSys.
998#@author  Ramon Gomez, ETSII Universidad de Sevilla
999#@date    2009-07-21
1000#@version 1.0.3 - Código trasladado de antigua función ogGetFsType.
1001#@author  Ramon Gomez, ETSII Universidad de Sevilla
1002#@date    2011-12-01
1003#@version 1.0.5 - Usar función ogIdToType para hacer la conversión id. a tipo.
1004#@author  Ramon Gomez, ETSII Universidad de Sevilla
1005#@date    2013-09-19
1006#*/ ##
1007function ogGetPartitionType ()
1008{
1009# Variables locales.
1010local ID TYPE
1011
1012# Si se solicita, mostrar ayuda.
1013if [ "$*" == "help" ]; then
1014    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
1015           "$FUNCNAME 1 1  =>  NTFS"
1016    return
1017fi
1018# Error si no se reciben 2 parámetros.
1019[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1020
1021# Detectar id. de tipo de partición y codificar al mnemonico.
1022ID=$(ogGetPartitionId "$1" "$2") || return $?
1023TYPE=$(ogIdToType "$ID")
1024echo "$TYPE"
1025}
1026
1027
1028#/**
1029#         ogHidePartition int_ndisk int_npartition
1030#@brief   Oculta un apartición visible.
1031#@param   int_ndisk      nº de orden del disco
1032#@param   int_npartition nº de orden de la partición
1033#@return  (nada)
1034#@exception OG_ERR_FORMAT    formato incorrecto.
1035#@exception OG_ERR_NOTFOUND  disco o particion no detectado (no es un dispositivo).
1036#@exception OG_ERR_PARTITION tipo de partición no reconocido.
1037#@version 1.0 - Versión en pruebas.
1038#@author  Ramon Gomez, ETSII Universidad de Sevilla
1039#@date    2010/01/12
1040#*/ ##
1041function ogHidePartition ()
1042{
1043# Variables locales.
1044local PART TYPE NEWTYPE
1045# Si se solicita, mostrar ayuda.
1046if [ "$*" == "help" ]; then
1047    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
1048           "$FUNCNAME 1 1"
1049    return
1050fi
1051# Error si no se reciben 2 parámetros.
1052[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1053PART=$(ogDiskToDev "$1" "$2") || return $?
1054
1055# Obtener tipo de partición.
1056TYPE=$(ogGetPartitionType "$1" "$2")
1057case "$TYPE" in
1058    NTFS)   NEWTYPE="HNTFS"  ;;
1059    FAT32)  NEWTYPE="HFAT32" ;;
1060    FAT16)  NEWTYPE="HFAT16" ;;
1061    FAT12)  NEWTYPE="HFAT12" ;;
1062    *)      ogRaiseError $OG_ERR_PARTITION "$TYPE"
1063            return $? ;;
1064esac
1065# Cambiar tipo de partición.
1066ogSetPartitionType $1 $2 $NEWTYPE
1067}
1068
1069
1070#/**
1071#         ogIdToType int_idpart
1072#@brief   Devuelve el identificador correspondiente a un tipo de partición.
1073#@param   int_idpart    identificador de tipo de partición.
1074#@return  str_parttype  mnemónico de tipo de partición.
1075#@exception OG_ERR_FORMAT   Formato incorrecto.
1076#@version 1.0.5 - Primera version para OpenGnSys
1077#@author  Ramon Gomez, ETSII Universidad Sevilla
1078#@date    2013-02-07
1079#*/ ##
1080function ogIdToType ()
1081{
1082# Variables locales
1083local ID TYPE
1084
1085# Si se solicita, mostrar ayuda.
1086if [ "$*" == "help" ]; then
1087    ogHelp "$FUNCNAME" "$FUNCNAME int_idpart" \
1088           "$FUNCNAME 83  =>  LINUX"
1089    return
1090fi
1091# Error si no se recibe 1 parámetro.
1092[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1093
1094# Obtener valor hexadecimal de 4 caracteres rellenado con 0 por delante.
1095ID=$(printf "%4s" "$1" | tr ' ' '0')
1096case "${ID,,}" in
1097     0000)      TYPE="EMPTY" ;;
1098     0001)      TYPE="FAT12" ;;
1099     0005|000f) TYPE="EXTENDED" ;;
1100     0006|000e) TYPE="FAT16" ;;
1101     0007)      TYPE="NTFS" ;;
1102     000b|000c) TYPE="FAT32" ;;
1103     0011)      TYPE="HFAT12" ;;
1104     0012)      TYPE="COMPAQDIAG" ;;
1105     0016|001e) TYPE="HFAT16" ;;
1106     0017)      TYPE="HNTFS" ;;
1107     001b|001c) TYPE="HFAT32" ;;
1108     0042)      TYPE="WIN-DYNAMIC" ;;
1109     0082|8200) TYPE="LINUX-SWAP" ;;
1110     0083|8300) TYPE="LINUX" ;;
1111     008e|8E00) TYPE="LINUX-LVM" ;;
1112     00a5|a503) TYPE="FREEBSD" ;;
1113     00a6)      TYPE="OPENBSD" ;;
1114     00a7)      TYPE="CACHE" ;;         # (compatibilidad con Brutalix)
1115     00af|af00) TYPE="HFS" ;;
1116     00be|be00) TYPE="SOLARIS-BOOT" ;;
1117     00bf|bf0[0145]) TYPE="SOLARIS" ;;
1118     00ca|ca00) TYPE="CACHE" ;;
1119     00da)      TYPE="DATA" ;;
1120     00ee)      TYPE="GPT" ;;
1121     00ef|ef00) TYPE="EFI" ;;
1122     00fb)      TYPE="VMFS" ;;
1123     00fd|fd00) TYPE="LINUX-RAID" ;;
1124     0700)      TYPE="WINDOWS" ;;
1125     0c01)      TYPE="WIN-RESERV" ;;
1126     7f00)      TYPE="CHROMEOS-KRN" ;;
1127     7f01)      TYPE="CHROMEOS" ;;
1128     7f02)      TYPE="CHROMEOS-RESERV" ;;
1129     8301)      TYPE="LINUX-RESERV" ;;
1130     a500)      TYPE="FREEBSD-DISK" ;;
1131     a501)      TYPE="FREEBSD-BOOT" ;;
1132     a502)      TYPE="FREEBSD-SWAP" ;;
1133     ab00)      TYPE="HFS-BOOT" ;;
1134     af01)      TYPE="HFS-RAID" ;;
1135     bf02)      TYPE="SOLARIS-SWAP" ;;
1136     bf03)      TYPE="SOLARIS-DISK" ;;
1137     ef01)      TYPE="MBR" ;;
1138     ef02)      TYPE="BIOS-BOOT" ;;
1139     10000)     TYPE="LVM-LV" ;;
1140     10010)     TYPE="ZFS-VOL" ;;
1141     *)         TYPE="UNKNOWN" ;;
1142esac
1143echo "$TYPE"
1144}
1145
1146
1147#         ogIsDiskLocked int_ndisk
1148#@brief   Comprueba si un disco está bloqueado por una operación de uso exclusivo.
1149#@param   int_ndisk      nº de orden del disco
1150#@return  Código de salida: 0 - bloqueado, 1 - sin bloquear o error.
1151#@note    Los ficheros de bloqueo se localizan en \c /var/lock/dev, siendo \c dev el dispositivo de la partición o de su disco, sustituyendo el carácter "/" por "-".
1152#@version 1.1.0 - Primera versión para OpenGnsys.
1153#@author  Ramon Gomez, ETSII Universidad de Sevilla
1154#@date    2016-04-08
1155#*/ ##
1156function ogIsDiskLocked ()
1157{
1158# Variables locales
1159local DISK LOCKFILE
1160
1161# Si se solicita, mostrar ayuda.
1162if [ "$*" == "help" ]; then
1163    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
1164           "if $FUNCNAME 1; then ... ; fi"
1165    return
1166fi
1167# Falso, en caso de error.
1168[ $# == 1 ] || return 1
1169DISK="$(ogDiskToDev $1 2>/dev/null)" || return 1
1170
1171# Comprobar existencia de fichero de bloqueo para el disco.
1172LOCKFILE="/var/lock/lock${DISK//\//-}"
1173test -f $LOCKFILE
1174}
1175
1176
1177#/**
1178#         ogListPartitions int_ndisk
1179#@brief   Lista las particiones definidas en un disco.
1180#@param   int_ndisk  nº de orden del disco
1181#@return  str_parttype:int_partsize ...
1182#@exception OG_ERR_FORMAT   formato incorrecto.
1183#@exception OG_ERR_NOTFOUND disco o particion no detectado (no es un dispositivo).
1184#@note    Requisitos: \c parted \c awk
1185#@attention El nº de partición se indica por el orden de los párametros \c parttype:partsize
1186#@attention Las tuplas de valores están separadas por espacios.
1187#@version 0.9 - Primera versión para OpenGnSys
1188#@author  Ramon Gomez, ETSII Universidad de Sevilla
1189#@date    2009/07/24
1190#*/ ##
1191function ogListPartitions ()
1192{
1193# Variables locales.
1194local DISK PART NPARTS TYPE SIZE
1195
1196# Si se solicita, mostrar ayuda.
1197if [ "$*" == "help" ]; then
1198    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
1199           "$FUNCNAME 1  =>  NTFS:10000000 EXT3:5000000 LINUX-SWAP:1000000"
1200    return
1201fi
1202# Error si no se recibe 1 parámetro.
1203[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT "$FORMAT" || return $?
1204
1205# Procesar la salida de \c parted .
1206DISK="$(ogDiskToDev $1)" || return $?
1207NPARTS=$(ogGetPartitionsNumber $1)
1208for (( PART = 1; PART <= NPARTS; PART++ )); do
1209    TYPE=$(ogGetPartitionType $1 $PART 2>/dev/null); TYPE=${TYPE:-EMPTY}
1210    SIZE=$(ogGetPartitionSize $1 $PART 2>/dev/null); SIZE=${SIZE:-0}
1211    echo -n "$TYPE:$SIZE "
1212done
1213echo
1214}
1215
1216
1217#/**
1218#         ogListPrimaryPartitions int_ndisk
1219#@brief   Metafunción que lista las particiones primarias no vacías de un disco.
1220#@param   int_ndisk  nº de orden del disco
1221#@see     ogListPartitions
1222#*/ ##
1223function ogListPrimaryPartitions ()
1224{
1225# Variables locales.
1226local PTTYPE PARTS
1227
1228# Si se solicita, mostrar ayuda.
1229if [ "$*" == "help" ]; then
1230    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
1231           "$FUNCNAME 1  =>  NTFS:10000000 EXT3:5000000 EXTENDED:1000000"
1232    return
1233fi
1234
1235PTTYPE=$(ogGetPartitionTableType $1) || return $?
1236PARTS=$(ogListPartitions "$@") || return $?
1237case "$PTTYPE" in
1238    GPT)    echo $PARTS | sed 's/\( EMPTY:0\)*$//' ;;
1239    MSDOS)  echo $PARTS | cut -sf1-4 -d" " | sed 's/\( EMPTY:0\)*$//' ;;
1240esac
1241}
1242
1243
1244#/**
1245#         ogListLogicalPartitions int_ndisk
1246#@brief   Metafunción que lista las particiones lógicas de una tabla tipo MSDOS.
1247#@param   int_ndisk  nº de orden del disco
1248#@see     ogListPartitions
1249#*/ ##
1250function ogListLogicalPartitions ()
1251{
1252# Variables locales.
1253local PTTYPE PARTS
1254
1255# Si se solicita, mostrar ayuda.
1256if [ "$*" == "help" ]; then
1257    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
1258           "$FUNCNAME 1  =>  LINUX-SWAP:999998"
1259    return
1260fi
1261PTTYPE=$(ogGetPartitionTableType $1) || return $?
1262[ "$PTTYPE" == "MSDOS" ] || ogRaiseError $OG_ERR_PARTITION "" || return $?
1263PARTS=$(ogListPartitions "$@") || return $?
1264echo $PARTS | cut -sf5- -d" "
1265}
1266
1267
1268#/**
1269#         ogLockDisk int_ndisk
1270#@brief   Genera un fichero de bloqueo para un disco en uso exlusivo.
1271#@param   int_ndisk      nº de orden del disco
1272#@return  (nada)
1273#@exception OG_ERR_FORMAT    Formato incorrecto.
1274#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
1275#@note    El fichero de bloqueo se localiza en \c /var/lock/disk, siendo \c disk el dispositivo del disco, sustituyendo el carácter "/" por "-".
1276#@version 1.1.0 - Primera versión para OpenGnsys.
1277#@author  Ramon Gomez, ETSII Universidad de Sevilla
1278#@date    2016-04-07
1279#*/ ##
1280function ogLockDisk ()
1281{
1282# Variables locales
1283local DISK LOCKFILE
1284
1285# Si se solicita, mostrar ayuda.
1286if [ "$*" == "help" ]; then
1287    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
1288           "$FUNCNAME 1"
1289    return
1290fi
1291# Error si no se recibe 1 parámetro.
1292[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1293
1294# Obtener partición.
1295DISK="$(ogDiskToDev $1)" || return $?
1296
1297# Crear archivo de bloqueo exclusivo.
1298LOCKFILE="/var/lock/lock${DISK//\//-}"
1299touch $LOCKFILE
1300}
1301
1302
1303#/**
1304#         ogSetPartitionActive int_ndisk int_npartition
1305#@brief   Establece cual es la partición activa de un disco.
1306#@param   int_ndisk      nº de orden del disco
1307#@param   int_npartition nº de orden de la partición
1308#@return  (nada).
1309#@exception OG_ERR_FORMAT   Formato incorrecto.
1310#@exception OG_ERR_NOTFOUND Disco o partición no corresponden con un dispositivo.
1311#@note    Requisitos: parted
1312#@version 0.1 -  Integracion para Opengnsys  -  EAC: SetPartitionActive() en ATA.lib
1313#@author  Antonio J. Doblas Viso, Universidad de Malaga
1314#@date    2008/10/27
1315#@version 0.9 - Primera version compatible con OpenGnSys.
1316#@author  Ramon Gomez, ETSII Universidad de Sevilla
1317#@date    2009/09/17
1318#*/ ##
1319function ogSetPartitionActive ()
1320{
1321# Variables locales
1322local DISK PART
1323
1324# Si se solicita, mostrar ayuda.
1325if [ "$*" == "help" ]; then
1326    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
1327           "$FUNCNAME 1 1"
1328    return
1329fi
1330# Error si no se reciben 2 parámetros.
1331[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1332
1333# Comprobar que el disco existe y activar la partición indicada.
1334DISK="$(ogDiskToDev $1)" || return $?
1335PART="$(ogDiskToDev $1 $2)" || return $?
1336parted -s $DISK set $2 boot on 2>/dev/null
1337}
1338
1339
1340#/**
1341#         ogSetPartitionId int_ndisk int_npartition hex_partid
1342#@brief   Cambia el identificador de la partición.
1343#@param   int_ndisk      nº de orden del disco
1344#@param   int_npartition nº de orden de la partición
1345#@param   hex_partid     identificador de tipo de partición
1346#@return  (nada)
1347#@exception OG_ERR_FORMAT     Formato incorrecto.
1348#@exception OG_ERR_NOTFOUND   Disco o partición no corresponden con un dispositivo.
1349#@exception OG_ERR_OUTOFLIMIT Valor no válido.
1350#@exception OG_ERR_PARTITION  Error al cambiar el id. de partición.
1351#@attention Requisitos: fdisk, sgdisk
1352#@version 0.1 -  Integracion para Opengnsys  - SetPartitionType() en ATA.lib
1353#@author  Antonio J. Doblas Viso. Universidad de Malaga
1354#@date    2008/10/27
1355#@version 1.0.4 - Soporte para discos GPT.
1356#@author  Universidad de Huelva
1357#@date    2012/03/13
1358#@version 1.0.5 - Utiliza el id. de tipo de partición (no el mnemónico)
1359#@author  Universidad de Huelva
1360#@date    2012/05/14
1361#*/ ##
1362function ogSetPartitionId ()
1363{
1364# Variables locales
1365local DISK PART PTTYPE ID
1366
1367# Si se solicita, mostrar ayuda.
1368if [ "$*" == "help" ]; then
1369    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition hex_partid" \
1370           "$FUNCNAME 1 1 7"
1371    return
1372fi
1373# Error si no se reciben 3 parámetros.
1374[ $# == 3 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1375
1376# Sustituye nº de disco y nº partición por su dispositivo.
1377DISK=$(ogDiskToDev $1) || return $?
1378PART=$(ogDiskToDev $1 $2) || return $?
1379# Error si el id. de partición no es hexadecimal.
1380ID="${3^^}"
1381[[ "$ID" =~ ^[0-9A-F]+$ ]] || ogRaiseError $OG_ERR_OUTOFLIMIT "$3" || return $?
1382
1383# Elección del tipo de partición.
1384PTTYPE=$(ogGetPartitionTableType $1)
1385case "$PTTYPE" in
1386    GPT)    sgdisk -t$2:$ID $DISK 2>/dev/null ;;
1387    MSDOS)  sfdisk --id $DISK $2 $ID 2>/dev/null ;;
1388    *)      ogRaiseError $OG_ERR_OUTOFLIMIT "$1,$PTTYPE"
1389            return $? ;;
1390esac
1391
1392# MSDOS) Correcto si fdisk sin error o con error pero realiza Syncing
1393if [ "${PIPESTATUS[1]}" == "0" -o $? -eq 0 ]; then
1394    partprobe $DISK 2>/dev/null
1395    return 0
1396else
1397    ogRaiseError $OG_ERR_PARTITION "$1,$2,$3"
1398    return $?
1399fi
1400}
1401
1402
1403#/**
1404#         ogSetPartitionSize int_ndisk int_npartition int_size
1405#@brief   Muestra el tamano en KB de una particion determinada.
1406#@param   int_ndisk      nº de orden del disco
1407#@param   int_npartition nº de orden de la partición
1408#@param   int_size       tamaño de la partición (en KB)
1409#@return  (nada)
1410#@exception OG_ERR_FORMAT   formato incorrecto.
1411#@exception OG_ERR_NOTFOUND disco o particion no detectado (no es un dispositivo).
1412#@note    Requisitos: sfdisk, awk
1413#@todo    Compruebar que el tamaño sea numérico positivo y evitar que pueda solaparse con la siguiente partición.
1414#@version 0.9 - Primera versión para OpenGnSys
1415#@author  Ramon Gomez, ETSII Universidad de Sevilla
1416#@date    2009/07/24
1417#*/ ##
1418function ogSetPartitionSize ()
1419{
1420# Variables locales.
1421local DISK PART SIZE
1422
1423# Si se solicita, mostrar ayuda.
1424if [ "$*" == "help" ]; then
1425    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition int_size" \
1426           "$FUNCNAME 1 1 10000000"
1427    return
1428fi
1429# Error si no se reciben 3 parámetros.
1430[ $# == 3 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1431
1432# Obtener el tamaño de la partición.
1433DISK="$(ogDiskToDev $1)" || return $?
1434PART="$(ogDiskToDev $1 $2)" || return $?
1435# Convertir tamaño en KB a sectores de 512 B.
1436SIZE=$[$3*2] || ogRaiseError $OG_ERR_FORMAT || return $?
1437# Redefinir el tamaño de la partición.
1438sfdisk -f -uS -N$2 $DISK <<< ",$SIZE" &>/dev/null || ogRaiseError $OG_ERR_PARTITION "$1,$2" || return $?
1439partprobe $DISK 2>/dev/null
1440}
1441
1442
1443#/**
1444#         ogSetPartitionType int_ndisk int_npartition str_type
1445#@brief   Cambia el identificador de la partición.
1446#@param   int_ndisk      nº de orden del disco
1447#@param   int_npartition nº de orden de la partición
1448#@param   str_type       mnemónico de tipo de partición
1449#@return  (nada)
1450#@attention Requisitos: fdisk, sgdisk
1451#@version 0.1 -  Integracion para Opengnsys  - SetPartitionType() en ATA.lib
1452#@author  Antonio J. Doblas Viso. Universidad de Malaga
1453#@date    2008/10/27
1454#@version 1.0.4 - Soporte para discos GPT.
1455#@author  Universidad de Huelva
1456#@date    2012/03/13
1457#@version 1.0.5 - Renombrada de ogSetPartitionId.
1458#@author  Ramon Gomez, ETSII Universidad de Sevilla
1459#@date    2013/03/07
1460#*/ ##
1461function ogSetPartitionType ()
1462{
1463# Variables locales
1464local DISK PART PTTYPE ID
1465
1466# Si se solicita, mostrar ayuda.
1467if [ "$*" == "help" ]; then
1468    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition str_type" \
1469           "$FUNCNAME 1 1 NTFS"
1470    return
1471fi
1472# Error si no se reciben 3 parámetros.
1473[ $# == 3 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1474
1475# Sustituye nº de disco por su dispositivo.
1476DISK=`ogDiskToDev $1` || return $?
1477PART=`ogDiskToDev $1 $2` || return $?
1478
1479# Elección del tipo de partición.
1480PTTYPE=$(ogGetPartitionTableType $1)
1481ID=$(ogTypeToId "$3" "$PTTYPE")
1482[ -n "$ID" ] || ogRaiseError $OG_ERR_FORMAT "$3,$PTTYPE" || return $?
1483ogSetPartitionId $1 $2 $ID
1484}
1485
1486
1487#/**
1488#         ogTypeToId str_parttype [str_tabletype]
1489#@brief   Devuelve el identificador correspondiente a un tipo de partición.
1490#@param   str_parttype  mnemónico de tipo de partición.
1491#@param   str_tabletype mnemónico de tipo de tabla de particiones (MSDOS por defecto).
1492#@return  int_idpart    identificador de tipo de partición.
1493#@exception OG_ERR_FORMAT   Formato incorrecto.
1494#@note    tabletype = { MSDOS, GPT },   (MSDOS, por defecto)
1495#@version 0.1 -  Integracion para Opengnsys  -  EAC: TypeFS () en ATA.lib
1496#@author  Antonio J. Doblas Viso, Universidad de Malaga
1497#@date    2008/10/27
1498#@version 0.9 - Primera version para OpenGnSys
1499#@author  Ramon Gomez, ETSII Universidad Sevilla
1500#@date    2009-12-14
1501#@version 1.0.4 - Soportar discos GPT (sustituye a ogFsToId).
1502#@author  Universidad de Huelva
1503#@date    2012/03/30
1504#*/ ##
1505function ogTypeToId ()
1506{
1507# Variables locales
1508local PTTYPE ID=""
1509
1510# Si se solicita, mostrar ayuda.
1511if [ "$*" == "help" ]; then
1512    ogHelp "$FUNCNAME" "$FUNCNAME str_parttype [str_tabletype]" \
1513           "$FUNCNAME LINUX  =>  83" \
1514           "$FUNCNAME LINUX MSDOS  =>  83"
1515    return
1516fi
1517# Error si no se reciben 1 o 2 parámetros.
1518[ $# -lt 1 -o $# -gt 2 ] && (ogRaiseError $OG_ERR_FORMAT; return $?)
1519
1520# Asociar id. de partición para su mnemónico.
1521PTTYPE=${2:-"MSDOS"}
1522case "$PTTYPE" in
1523    GPT) # Se incluyen mnemónicos compatibles con tablas MSDOS.
1524        case "$1" in
1525            EMPTY)      ID=0 ;;
1526            WINDOWS|NTFS|EXFAT|FAT32|FAT16|FAT12|HNTFS|HFAT32|HFAT16|HFAT12)
1527                        ID=0700 ;;
1528            WIN-RESERV) ID=0C01 ;;
1529            CHROMEOS-KRN) ID=7F00 ;;
1530            CHROMEOS)   ID=7F01 ;;
1531            CHROMEOS-RESERV) ID=7F02 ;;
1532            LINUX-SWAP) ID=8200 ;;
1533            LINUX|EXT[234]|REISERFS|REISER4|XFS|JFS)
1534                        ID=8300 ;;
1535            LINUX-RESERV) ID=8301 ;;
1536            LINUX-LVM)  ID=8E00 ;;
1537            FREEBSD-DISK) ID=A500 ;;
1538            FREEBSD-BOOT) ID=A501 ;;
1539            FREEBSD-SWAP) ID=A502 ;;
1540            FREEBSD)    ID=A503 ;;
1541            HFS-BOOT)   ID=AB00 ;;
1542            HFS|HFS+)   ID=AF00 ;;
1543            HFSPLUS)    ID=AF00 ;;
1544            HFS-RAID)   ID=AF01 ;;
1545            SOLARIS-BOOT) ID=BE00 ;;
1546            SOLARIS)    ID=BF00 ;;
1547            SOLARIS-SWAP) ID=BF02 ;;
1548            SOLARIS-DISK) ID=BF03 ;;
1549            CACHE)      ID=CA00;;
1550            EFI)        ID=EF00 ;;
1551            LINUX-RAID) ID=FD00 ;;
1552        esac
1553        ;;
1554    MSDOS)
1555        case "$1" in
1556            EMPTY)      ID=0  ;;
1557            FAT12)      ID=1  ;;
1558            EXTENDED)   ID=5  ;;
1559            FAT16)      ID=6  ;;
1560            WINDOWS|NTFS|EXFAT)
1561                        ID=7  ;;
1562            FAT32)      ID=b  ;;
1563            HFAT12)     ID=11 ;;
1564            HFAT16)     ID=16 ;;
1565            HNTFS)      ID=17 ;;
1566            HFAT32)     ID=1b ;;
1567            LINUX-SWAP) ID=82 ;;
1568            LINUX|EXT[234]|REISERFS|REISER4|XFS|JFS)
1569                        ID=83 ;;
1570            LINUX-LVM)  ID=8e ;;
1571            FREEBSD)    ID=a5 ;;
1572            OPENBSD)    ID=a6 ;;
1573            HFS|HFS+)   ID=af ;;
1574            SOLARIS-BOOT) ID=be ;;
1575            SOLARIS)    ID=bf ;;
1576            CACHE)      ID=ca ;;
1577            DATA)       ID=da ;;
1578            GPT)        ID=ee ;;
1579            EFI)        ID=ef ;;
1580            VMFS)       ID=fb ;;
1581            LINUX-RAID) ID=fd ;;
1582        esac
1583        ;;
1584    LVM)
1585        case "$1" in
1586            LVM-LV)     ID=10000 ;;
1587        esac
1588        ;;
1589    ZVOL)
1590        case "$1" in
1591            ZFS-VOL)    ID=10010 ;;
1592        esac
1593        ;;
1594esac
1595echo $ID
1596}
1597
1598
1599#/**
1600#         ogUnhidePartition int_ndisk int_npartition
1601#@brief   Hace visible una partición oculta.
1602#@param   int_ndisk      nº de orden del disco
1603#@param   int_npartition nº de orden de la partición
1604#@return  (nada)
1605#@exception OG_ERR_FORMAT    formato incorrecto.
1606#@exception OG_ERR_NOTFOUND  disco o particion no detectado (no es un dispositivo).
1607#@exception OG_ERR_PARTITION tipo de partición no reconocido.
1608#@version 1.0 - Versión en pruebas.
1609#@author  Ramon Gomez, ETSII Universidad de Sevilla
1610#@date    2010/01/12
1611#*/ ##
1612function ogUnhidePartition ()
1613{
1614# Variables locales.
1615local PART TYPE NEWTYPE
1616# Si se solicita, mostrar ayuda.
1617if [ "$*" == "help" ]; then
1618    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
1619           "$FUNCNAME 1 1"
1620    return
1621fi
1622# Error si no se reciben 2 parámetros.
1623[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1624PART=$(ogDiskToDev "$1" "$2") || return $?
1625
1626# Obtener tipo de partición.
1627TYPE=$(ogGetPartitionType "$1" "$2")
1628case "$TYPE" in
1629    HNTFS)   NEWTYPE="NTFS"  ;;
1630    HFAT32)  NEWTYPE="FAT32" ;;
1631    HFAT16)  NEWTYPE="FAT16" ;;
1632    HFAT12)  NEWTYPE="FAT12" ;;
1633    *)      ogRaiseError $OG_ERR_PARTITION "$TYPE"
1634            return $? ;;
1635esac
1636# Cambiar tipo de partición.
1637ogSetPartitionType $1 $2 $NEWTYPE
1638}
1639
1640
1641#/**
1642#         ogUnlockDisk int_ndisk
1643#@brief   Elimina el fichero de bloqueo para un disco.
1644#@param   int_ndisk      nº de orden del disco
1645#@return  (nada)
1646#@exception OG_ERR_FORMAT    Formato incorrecto.
1647#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
1648#@note    El fichero de bloqueo se localiza en \c /var/lock/disk, siendo \c disk el dispositivo del disco, sustituyendo el carácter "/" por "-".
1649#@version 1.1.0 - Primera versión para OpenGnsys.
1650#@author  Ramon Gomez, ETSII Universidad de Sevilla
1651#@date    2016-04-08
1652#*/ ##
1653function ogUnlockDisk ()
1654{
1655# Variables locales
1656local DISK LOCKFILE
1657
1658# Si se solicita, mostrar ayuda.
1659if [ "$*" == "help" ]; then
1660    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" \
1661           "$FUNCNAME 1"
1662    return
1663fi
1664# Error si no se recibe 1 parámetro.
1665[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
1666
1667# Obtener partición.
1668DISK="$(ogDiskToDev $1)" || return $?
1669
1670# Borrar archivo de bloqueo exclusivo.
1671LOCKFILE="/var/lock/lock${DISK//\//-}"
1672rm -f $LOCKFILE
1673}
1674
1675
1676#/**
1677#         ogUpdatePartitionTable
1678#@brief   Fuerza al kernel releer la tabla de particiones de los discos duros
1679#@param   no requiere
1680#@return  informacion propia de la herramienta
1681#@note    Requisitos: \c partprobe
1682#@warning pendiente estructurar la funcion a opengnsys
1683#@version 0.1 -  Integracion para Opengnsys  -  EAC: UpdatePartitionTable() en ATA.lib
1684#@author  Antonio J. Doblas Viso. Universidad de Malaga
1685#@date    27/10/2008
1686#*/ ##
1687function ogUpdatePartitionTable ()
1688{
1689local i
1690for i in `ogDiskToDev`
1691do
1692        partprobe $i
1693done
1694}
Note: See TracBrowser for help on using the repository browser.